import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class DiffusionEq extends Frame
{  public double Pi=3.1415926535897932385;
   public int ID1, ID2;public double ER;
   public double LeftP, TopP, sX, sY;
   public double currentX, currentY; // ݂̕`ʒu
   public DiffusionEq()
   {  setSize(1100,700);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private double[][][] InitialT(int KX, int KY)
   {  double [][][]T=new double[2][KX+1][KY+1];
      for(int j = 0; j<= KY; j++)for(int i = 0; i <= KX; i++) T[0][i][j] = T[1][i][j] = 0;
      return T;
   }
   private double[][] InitialV(int KX, int KY)
   {  double [][]V=new double[KX+1][KY+1];
      for(int j = 0; j<= KY; j++)for(int i = 0; i <= KX; i++) V[i][j] = 0;
      return V;
   } 
   private double[][] InitialU(int KX, int KY, double DY)
   {  double [][]U=new double[KX+1][KY+1];
      for(int j = 0; j<= KY; j++)
      {  double YY= DY * (double)j; YY = 50.0 * YY * (1.0 - YY);
         for(int i = 0; i <= KX; i++) U[i][j] = YY;
      }
      return U;
   }
   private void BoundaryCondition(double [][][] T, int KX, int KY)
   {  int i,j; 
      for(j = 0; j<= KY; j++)
      { T[ID1][0][j] = 0; T[ID1][KX][j] = T[ID1][KX - 1][j];
      }
      for(i = 0; i<= KX; i++) T[ID1][i][0] = T[ID1][i][KY] = 0;
      for(i = ((KX + 1) / 4 - 1) ; i < (KX + 1) / 2; i++)  T[ID1][i][0] = 1.0;
   }
   
  private void Comp(double[][][]T,double[][] V, double[][] U, int KX, int KY,
                   double R1, double R2, double R3, double R4)
  {  for(int j = 1; j< KY; j++)for(int i = 1; i< KX; i++)
        T[ID2][i][j] = T[ID1][i][j]
                     - R1 * U[i][j] * (T[ID1][i + 1][j] - T[ID1][i - 1][j]) 
                     - R2 * V[i][j] * (T[ID1][i][j + 1] - T[ID1][i][j - 1])
                     + R3 * (T[ID1][i + 1][j] - 2.0 * T[ID1][i][j] + T[ID1][i - 1][j])
                     + R4 * (T[ID1][i][j + 1] - 2.0 * T[ID1][i][j] + T[ID1][i][j - 1]);
     int ID = ID2; ID2 = ID1; ID1 = ID;
  }
  private int DrawResult(Graphics g, int IN,double[][][] T,int  KX,int  KY,int N)
  {
    double X1 = (double) ((N % 5) * 200)+20; double Y1=(double)( N / 5)*300+100;
    drawInit(X1, Y1, 2, 2); int i, j;
    g.drawString("  = "+ IN,Xpos(0),Ypos(-1));    

    double Umax = 1; double Umin = 0;
    double UDX = (Umax - Umin) / 256;
    for(j = 1; j<KY; j++) for(i = 1; i<KX;i++)
    {  int ID=(int)((T[ID1][i][j]- Umin) / UDX);
       if(ID>255) ID=255;
        g.setColor(new Color(ID, ID, ID));
        g.fillRect(Xpos(i),Ypos(j),2,2);
    }
    return N+1;
  }
  private void Solution(Graphics g)
  { int i;
    int KX = 100; int KY = 100; double DT = 0.00001; int NumLoop=5000; int Ndisp=500;
    g.drawString("ԍ = " + round(DT,8)+ " b  bV = "+ KX +" ~ " + KY,50,50);
    double DX = 1.0 / KX      ; double DY = 1.0 / KY;
    double R1 = 2 * DT / DX   ; double R2 = 2 * DT / DY;
    double R3 = DT / (DX * DX); double R4 = DT / (DY * DY);
    int N = 0; ID1 = 0; ID2 = 1;
    double[][][] T = InitialT(KX, KY);
    double  [][] V = InitialV(KX, KY);
    double  [][] U = InitialU(KX, KY, DY);
    for(i = 1; i <= NumLoop; i++)
    { BoundaryCondition(T, KX, KY);
      Comp(T, V, U, KX, KY, R1, R2, R3, R4);
      if((i % Ndisp) == 0)  N = DrawResult(g, i, T, KX, KY, N);
    }
  }
   public void drawInit(double X1, double Y1, double SX, double SY)
   {  LeftP = X1; TopP = Y1; sX = SX; sY = SY;
   }
   public int Xpos(double X)
   {  return (int)(LeftP + X * sX);}
   public int Ypos(double Y)
   {  return (int)(TopP  + Y * sY);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.fillOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawCircle(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawRect(Graphics g, double X, double Y)
   {  g.drawRect(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }
   private double MaxValue(double[][][]U, int KX,int KY)
   {  double V = U[0][0][0];int i,j,k;
      for(k = 0; k < 2; k++) for(i = 0; i < KX; i++)
          for(j = 0; j < KY; j++) if(U[k][i][j]>V) V= U[k][i][j];
      return V;
   }
   private double MinValue(double[][][]U, int KX,int KY)
   {  double V = U[0][0][0];int i,j,k;
      for(k = 0; k < 2; k++) for(i = 0; i < KX; i++)
          for(j = 0; j < KY; j++) if(U[k][i][j]<V) V= U[k][i][j];
      return V;
   }
   public void paint(Graphics g)
   { setTitle("MgU");
     Solution(g);
   } 
   public static void main(String[] args)
   {  Frame w = new DiffusionEq();
      w.setVisible(true);
   }
}
